{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DuplicateRecordFields #-}
{-# LANGUAGE NamedFieldPuns #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE RecordWildCards #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-unused-matches #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.GuardDuty.Types.MalwareProtectionConfiguration
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.GuardDuty.Types.MalwareProtectionConfiguration where

import qualified Amazonka.Core as Core
import qualified Amazonka.Core.Lens.Internal as Lens
import qualified Amazonka.Data as Data
import Amazonka.GuardDuty.Types.ScanEc2InstanceWithFindings
import qualified Amazonka.Prelude as Prelude

-- | Describes whether Malware Protection will be enabled as a data source.
--
-- /See:/ 'newMalwareProtectionConfiguration' smart constructor.
data MalwareProtectionConfiguration = MalwareProtectionConfiguration'
  { -- | Describes the configuration of Malware Protection for EC2 instances with
    -- findings.
    scanEc2InstanceWithFindings :: Prelude.Maybe ScanEc2InstanceWithFindings
  }
  deriving (Prelude.Eq, Prelude.Read, Prelude.Show, Prelude.Generic)

-- |
-- Create a value of 'MalwareProtectionConfiguration' with all optional fields omitted.
--
-- Use <https://hackage.haskell.org/package/generic-lens generic-lens> or <https://hackage.haskell.org/package/optics optics> to modify other optional fields.
--
-- The following record fields are available, with the corresponding lenses provided
-- for backwards compatibility:
--
-- 'scanEc2InstanceWithFindings', 'malwareProtectionConfiguration_scanEc2InstanceWithFindings' - Describes the configuration of Malware Protection for EC2 instances with
-- findings.
newMalwareProtectionConfiguration ::
  MalwareProtectionConfiguration
newMalwareProtectionConfiguration =
  MalwareProtectionConfiguration'
    { scanEc2InstanceWithFindings =
        Prelude.Nothing
    }

-- | Describes the configuration of Malware Protection for EC2 instances with
-- findings.
malwareProtectionConfiguration_scanEc2InstanceWithFindings :: Lens.Lens' MalwareProtectionConfiguration (Prelude.Maybe ScanEc2InstanceWithFindings)
malwareProtectionConfiguration_scanEc2InstanceWithFindings = Lens.lens (\MalwareProtectionConfiguration' {scanEc2InstanceWithFindings} -> scanEc2InstanceWithFindings) (\s@MalwareProtectionConfiguration' {} a -> s {scanEc2InstanceWithFindings = a} :: MalwareProtectionConfiguration)

instance
  Prelude.Hashable
    MalwareProtectionConfiguration
  where
  hashWithSalt
    _salt
    MalwareProtectionConfiguration' {..} =
      _salt
        `Prelude.hashWithSalt` scanEc2InstanceWithFindings

instance
  Prelude.NFData
    MalwareProtectionConfiguration
  where
  rnf MalwareProtectionConfiguration' {..} =
    Prelude.rnf scanEc2InstanceWithFindings

instance Data.ToJSON MalwareProtectionConfiguration where
  toJSON MalwareProtectionConfiguration' {..} =
    Data.object
      ( Prelude.catMaybes
          [ ("scanEc2InstanceWithFindings" Data..=)
              Prelude.<$> scanEc2InstanceWithFindings
          ]
      )
